#!/usr/bin/python
########################################################################
#                               potshop                                #
#                     copyright 2009 Louis Taylor                      #
#     this program is free software; you can redistribute it and/or    #
#    modify it under the terms of the GNU Library General Public       #
#    License as published by the Free Software Foundation; either      #
#    version 3 of the License, or (at your option) any later version.  #
#                                                                      #
#    this program is distributed in the hope that it will be useful,   #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of    #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU #
#    Library General Public License for more details.                  #
#                                                                      #
#    You should have received a copy of the GNU Library General Public #
#    License along with this program; If not, write to the Free        #
#    Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,   #
#    MA  02110-1301 USA                                                #
########################################################################
 
import wxversion
wxversion.select('2.8')
import wx
import wx.lib.filebrowsebutton
from wx.lib.wordwrap import wordwrap
import os, sys, thread
import potlib, globaldata
import re #for regexs

from potlib import potdatabase

potShopversion = 'beta 1.1.2'
iconname = 'potIcon.png'
programdir = os.path.split(sys.argv[0])[0]
icon = os.path.join(programdir, iconname)
templatedir = os.path.join(programdir, 'templates')

home = os.getenv('HOME')
potdir = '.potshop'
databasefilename = 'potNumberDatabase'
configdir = os.path.join( home, potdir )
homethumbdir = os.path.join( configdir, 'thumbs/' )
prefrences = os.path.join( configdir, 'saved_prefs' )

try:
    globaldata.potpath = open(prefrences, 'r').read()
except IOError:
    globaldata.potpath = os.getenv('HOME')
    
print 'globaldata.potpath: ', globaldata.potpath

if not os.path.exists(homethumbdir):
    os.system('mkdir -p %s' % homethumbdir )

#thumbnailtemp = os.path.join( templatedir, '.thumbnail.png') #not needed i think
nullpot = os.path.join(programdir, 'nopotIcon.png') #path to 'no pot' icon
inkscapepot = os.path.join(programdir, 'potInInkscape.png') #path to editing in inkscape icon

globaldata.imageToOpen = ''  #this is the file that has been dropped on the window
globaldata.dragged = False

#dpi for exporting
globaldata.dpi = 300

globaldata.inkscape = 'closed' #bit to start globaldata.inkscape to check if inkscape is open

#TODO get this bit to load the pots
globaldata.lastpot = potlib.lastpot()
globaldata.databaselist = potdatabase()
print globaldata.databaselist.pots()

wildcard = "tagged image file format (*.tif)|*.tif|" \
        "windows bitmap (*.bmp)|*.bmp|" \
        " JPEG (*.jpg)|*.jpg" \
        "All files (*.*)|*.*"\
        
if os.path.isdir(templatedir) == False:
    raise Exception, 'template dir <%s> not found' % templatedir

templates = []

for file in os.listdir(templatedir):
    if os.path.splitext(file)[1] == '.pvg':
        #print 'adding', file
        templates = templates + [file]
    else:
        pass
        
class FileDrop(wx.FileDropTarget):
    def __init__(self, window):
        wx.FileDropTarget.__init__(self)
        self.window = window
    def OnDropFiles(self, x, y, filenames):
        print filenames[0]
        globaldata.imageToOpen = filenames[0]
        globaldata.dragged = True

def inkscape(filetoload):
    globaldata.inkscape = 'open'
    
    pngfile = os.path.splitext(filetoload)[0] + '.png'
    tifile = os.path.splitext(filetoload)[0] + '.tif'
    
    os.system('''inkscape --verb=FullScreen '%s' ''' % filetoload)
    
    #TODO get rid of the ref. pic
    
    svgfile = open(filetoload, 'r').read()
    
    regex = re.compile( '<image\n.*\n.*\n.*\n.*\n.*>') #compile regex
    svgwithnopic = regex.sub( '\n', svgfile) #replace everything matched with the regex in *svgfile* with '\n'
    open(filetoload, 'w').write(svgwithnopic)
    
    #load inkscape without gui and save pot to png format
    os.system('''inkscape -z -D -e='%s' --export-dpi=%s -b 'rgb(256, 256, 256)' '%s'
    convert '%s' '%s' ''' % (pngfile, globaldata.dpi, filetoload, pngfile, tifile) )
    #then convert this to tiff
    globaldata.inkscape = 'needs_reloading'
    
def create(parent):
    return Frame(parent)

[wxID_Frame, wxID_FrameCOMBOBOX1, wxID_FrameFILEBROWSEBUTTONWITHHISTORY1, 
 wxID_FrameOK, wxID_FrameSTATICBITMAP1, wxID_FrameSTATICBOX1, 
] = [wx.NewId() for _init_ctrls in range(6)]


class Frame(wx.Frame):
    def _init_ctrls(self, prnt):
        #bit of class variables
        self.sampling = 1
        self.bitmapfile = ''
        
        wx.Frame.__init__(self, id=wxID_Frame, name='', parent=prnt,
              pos=wx.Point(678, 195), size=wx.Size(418, 582),
              style=wx.CAPTION | wx.MINIMIZE_BOX | wx.MINIMIZE | wx.CLOSE_BOX,
              title=u'potShop ' + potShopversion)
        self.Center(wx.BOTH)
        self.SetThemeEnabled(True)
        self.SetToolTipString(u'potShop')
        self.SetIcon(wx.Icon(icon, wx.BITMAP_TYPE_PNG) )

        self.timer = wx.Timer(self, 1)
        self.Bind(wx.EVT_TIMER, self.OnTimer, self.timer)
        self.timer.Start(300)
        
        self.Box = wx.StaticBox(id=wxID_FrameSTATICBOX1,
              label='Pot template', name='staticBox1', parent=self,
              pos=wx.Point(10, 10), size=wx.Size(400, 360), style=0)

        sw = wx.ScrolledWindow(self, pos=(32,45), size=(360, 250) )
        bmp = wx.Bitmap(nullpot)
        self.potref = wx.StaticBitmap(sw, -1, bmp)
        self.potref.Center(wx.BOTH)
        sw.SetScrollbars(0, 0, 70, 70)

        self.checkbox = wx.CheckBox(self, -1, 'use sampling for nicer resized pot previews', (20, 26))
        self.checkbox.SetValue(True)
        self.checkbox.SetToolTipString('''turns sampling on or off for scaled
down images. only used when the the thumbnails
are being generated''')
        wx.EVT_CHECKBOX(self, self.checkbox.GetId(), self.OnCheckbox)
                    
        self.potrefchoice = wx.ComboBox(choices=templates, # loaded template files  e.g. *.pvg in /templates
              id=wxID_FrameCOMBOBOX1, name='comboBox1', parent=self,
              pos=wx.Point(20, 330), size=wx.Size(380, 28) )
        self.potrefchoice.Bind(wx.EVT_COMBOBOX, self.OnSelect)
        self.potrefchoice.Bind(wx.EVT_TEXT, self.OnComboBoxText)
        self.potrefchoice.SetToolTipString('Choose a pot template that looks as close to the ref. image as poss')



        self.fileBrowse = wx.lib.filebrowsebutton.FileBrowseButtonWithHistory(buttonText=u'Open Pot ref image',
              dialogTitle=u'Choose an image file', fileMask=wildcard,
              id=wxID_FrameFILEBROWSEBUTTONWITHHISTORY1, initialValue='',
              labelText='File Entry:', parent=self, pos=wx.Point(10, 370),
              size=wx.Size(400, 48), startDirectory='.', style=wx.TAB_TRAVERSAL,
              toolTip='Type filename or click browse to choose file')
        
        #stuff for drag and drop
        dt = FileDrop(self)
        self.SetDropTarget(dt)
        
        self.ok = wx.Button(id=wx.ID_OK, name=u'ok',
              parent=self, pos=wx.Point(10, 420), size=wx.Size(400, 60) )
        self.ok.Bind(wx.EVT_BUTTON, self.OnOk)
        
        self.clearcachebutt = wx.Button(id=wx.ID_OK, label='clear thumbnail cache', name=u'clear thumbnail cache',
              parent=self, pos=wx.Point(259, 486) ) #, size=wx.Size(100, 30) )
        self.clearcachebutt.Bind(wx.EVT_BUTTON, self.OnClearCache)
        
        self.saveindir = wx.Button(id=wx.ID_OK, label='change the dir to put the pots in', name=u'clear thumbnail cache',
              parent=self, pos=wx.Point(10, 486) ) #, size=wx.Size(100, 30) )
        self.saveindir.Bind(wx.EVT_BUTTON, self.OnSetsavedir)
        self.saveindir.SetToolTipString('saving pots to ' + globaldata.potpath)
        
#copyed from crab
        self.exitbutton = wx.Button(id = wx.ID_CLOSE,
              name='button2', parent=self, pos=wx.Point(240, 525),
              size=wx.Size(170, 50))
        self.exitbutton.Bind(wx.EVT_BUTTON, self.OnExit)

        self.button2 = wx.Button(id = wx.ID_ABOUT,
              name='button2', parent=self, pos=wx.Point(10, 525),
              size=wx.Size(170, 50), style=0)
        self.button2.Bind(wx.EVT_BUTTON, self.OnAbout)


################################
##          events             #
################################

    def __init__(self, parent):
        self._init_ctrls(parent)
    
    def setnullpot(self):
        self.potref.SetBitmap(wx.Bitmap(nullpot) )
        self.potref.Center(wx.BOTH)
        self.Box.SetLabel('Pot template - image cannot be opened')
    
    def set_inkscape_pot(self, potnumber):
        self.potref.SetBitmap(wx.Bitmap(inkscapepot) )
        self.potref.Center(wx.BOTH)
        self.Box.SetLabel('editing Pot %s with inkscape' % potnumber)
        
    def setImage(self, imagefile):
        '''checks to see if an image file is in the
        templates dir and sets a defult image if it
        is not there'''
        
        def makeThumb():
            '''all things to make a thumb point to this for quickly changing it'''
            ##debuging stuff
            #print 'potlib.make_thumb(%s, %s, %s)' % (self.bitmapfile, newthumb, self.sampling)
            potlib.make_thumb(self.bitmapfile, newthumb, self.sampling)
            
        self.bitmapfile = os.path.join(templatedir, imagefile)
        
        if os.path.exists(self.bitmapfile) == True:
            
            #TODO redo the thumbs if sampling has been turned on or off
            if os.path.getsize(self.bitmapfile) > 7000: #this is probably about the biggest image 
                                                   #it can slurp up in one go, anything bigger
                                                   #is thumbnailed 
                newthumb = potlib.new_thumb_name(self.bitmapfile, homethumbdir)
                #the important line for working out where the thumbs are saved
                print newthumb
                
                if os.path.exists(newthumb) == True: #check if the thumb exists
                    if os.path.getctime(self.bitmapfile) > os.path.getctime(newthumb):
                        makeThumb()
                    else:
                        print 'newer thumb, skiping'
                else:
                    makeThumb()
                    
                self.potref.SetBitmap(wx.Bitmap( newthumb ) )
                self.potref.Center(wx.BOTH)

                self.Box.SetLabel('Pot template - resized image')
            else:
                self.potref.SetBitmap(wx.Bitmap( self.bitmapfile) )
                self.potref.Center(wx.BOTH)
                self.Box.SetLabel('Pot template')
        else:
            self.setnullpot()
        
    def OnCheckbox(self, event):
        if self.checkbox.GetValue() == True:
            self.sampling = 1
        else:
            self.sampling = 0
        
    def OnComboBoxText(self, event):
        globaldata.dragged = False
#        self.setImage( potlib.get_template_image(self.potrefchoice.GetValue()) )
        
    def OnSelect(self, event):
        self.setImage( potlib.get_template_image(self.potrefchoice.GetValue()) )
        
    def OnSetsavedir(self, event):
        '''saves the dir to save the pot SVGs in - $HOME by default'''
        dialog = wx.DirDialog(None, "Choose a directory:", defaultPath=globaldata.potpath,
              style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
        if dialog.ShowModal() == wx.ID_OK:
            dir = dialog.GetPath()
            potpathfile = open(prefrences, 'w').write(dir)
            
            try:
                globaldata.potpath = open(prefrences, 'r').read()
            except IOError:
                globaldata.potpath = os.getenv('HOME')
                
            self.saveindir.SetToolTipString('saving pots to ' + globaldata.potpath)
            
        dialog.Destroy()

    ##main bit for entering to the database and loading inkscape
    def EnterPot(self, number, diameter):
        '''and build and save pot'''
        print "You entered: %s" % number
        globaldata.databaselist.add_pot(number)
        template =  potlib.pngtosvg_path(self.bitmapfile)
        templatepath = os.path.join( templatedir, template )
        
        if not os.path.exists(templatepath):
            dialog = wx.MessageDialog(self, '''You must select a valid template''',
            '', wx.OK | wx.ICON_ERROR)
            dialog.ShowModal()
        else:
            xml = potlib.gen_svg(templatepath, number, self.fileBrowse.GetValue(), diameter)
            filename = 'pot_' + str(number)+'.svg'
            svggenpath = os.path.join(globaldata.potpath, filename)

            open(svggenpath, 'w').write(xml)
            
            if potlib.inkscape_is_installed() == False:
                dialog = wx.MessageDialog(self, '''Inkscape does not appear to be installed.
Potshop is useless without inkscape.''',
                '', wx.OK | wx.ICON_ERROR)
                dialog.ShowModal()
                dialog.Destroy()
                
            else:
                self.set_inkscape_pot(number)
                #os.system('inkscape %s' % svggenpath)
                thread.start_new(inkscape, (svggenpath,) )
                self.disable_widgits(self)
                
            
            
            #potlib.gen_svg(template, potnumber, background_image)
        
    def OnOk(self, event):
        def enter_diameter(self):
            dialog = wx.NumberEntryDialog(None, message='''Pot diameter must be entered''', min=1, max=100000000,
            prompt="Enter pot diameter:", caption='', value=22306)
            dialog.ShowModal()
            number = dialog.GetValue()
            return number
            
        dialog = wx.NumberEntryDialog(None, message='''Pots numbers must be entered for making
a filename and adding a number at the 
bottom of the image''', min=1, max=100000000,
        prompt="Enter pot number:", caption='', value=22306)#, style=wx.OK|wx.CANCEL)
        if dialog.ShowModal() == wx.ID_OK:
            number = dialog.GetValue()
            print globaldata.databaselist.pots()
            if number in globaldata.databaselist.pots():
                print '%s is already in the database' % number
                message = wx.MessageDialog(self, '''The pot '%s' already exists in the database.
Replacing it will overwrite its contents.
Do you want to replace it?''' % number, '', wx.NO | wx.YES | wx.ICON_QUESTION)
                if message.ShowModal() == wx.ID_YES:
                    print 'overwriting'
                    globaldata.databaselist.remove(number)
                    dialog.Destroy()
                    message.Destroy()
                    diameter = enter_diameter(self)
                    self.EnterPot(number, diameter)

                else:
                    print 'no'
                    self.OnOk(self)
            else:
                diameter = enter_diameter(self)
                self.EnterPot(number, diameter)
                
                dialog.Destroy()

    def OnClearCache(self, event):
        files = os.popen('cd %s; ls -m' % homethumbdir).read().split(', ')
        for file in files:
            file = file.replace('\n', '')
            try:
                print 'removing thumb file: ', file
                os.remove( os.path.join(homethumbdir, file) )
            except OSError:
                print 'OSError probably a directory'
                
    def enable_widgits(self, event):
        self.OnSelect(self) #load the thumbnail for template
        self.exitbutton.Enable()
        self.saveindir.Enable()
        self.clearcachebutt.Enable()
        self.ok.Enable()
        self.fileBrowse.Enable()
        self.potrefchoice.Enable()
        self.checkbox.Enable()
        
    def disable_widgits(self, event):
        self.exitbutton.Disable()
        self.saveindir.Disable()
        self.clearcachebutt.Disable()
        self.ok.Disable()
        self.fileBrowse.Disable()
        self.potrefchoice.Disable()
        self.checkbox.Disable()
        
    def OnTimer(self, event):
        if globaldata.dragged == True:
            self.fileBrowse.SetValue(globaldata.imageToOpen)
        if globaldata.inkscape == 'needs_reloading':
            globaldata.inkscape = 'closed'
            self.enable_widgits(self)
            
    def OnExit(self, event):
        quit()

    def OnAbout(self, event):
        info = wx.AboutDialogInfo()
        info.Name = 'PotShop'
        info.SetIcon(wx.Icon(icon, wx.BITMAP_TYPE_PNG))
        info.Version = potShopversion
        info.Copyright = '(C) 2009 Louis Taylor'
        info.Description = wordwrap(
            '''gnome pot template and database manager''',
            350, wx.ClientDC(self))
        info.Developers = ['louis']
        info.AddArtist('louis')


        info.License = wordwrap(licenseText, 500, wx.ClientDC(self))

        wx.AboutBox(info)

################################# licence ###########################
licenseText = '''
    this program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    this program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this program; If not, write to the Free
    Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    MA  02110-1301 USA'''

if __name__ == '__main__':
    app = wx.PySimpleApp()
    frame = create(None)
    frame.Show()

    app.MainLoop()
